#ifndef TemporaryZhenyuHanWrapper_Mt2_332_Calculator_H
#define TemporaryZhenyuHanWrapper_Mt2_332_Calculator_H

#include "Mt2/Mt2_332_Calculator.h"
#include "Minuit2/FCNBase.h"
#include <vector>

/** Adapted from http://daneel.physics.ucdavis.edu/~zhenyuhan/mt2.html
    which is described in 
    Minimal Kinematic Constraints and MT2
    arXiv:0810.5178
    Hsin-Chia Cheng, Zhenyu Han 
*/

namespace ZhenyuHan {
  class mt2;
}

namespace Mt2 {

  class TemporaryZhenyuHanWrapper_Mt2_332_Calculator : public Mt2_332_Calculator {
  public:
    double mt2_332(const LorentzTransverseVector& visibleA, // 3 d.o.f. 
		   const LorentzTransverseVector& visibleB, // 3 d.o.f.
		   const TwoVector& ptmiss,                 // 2 d.o.f.
		   const double mInvisible);
    double mt2_332_Sq(const LorentzTransverseVector& visibleA, // 3 d.o.f. 
		      const LorentzTransverseVector& visibleB, // 3 d.o.f.
		      const TwoVector& ptmiss,                 // 2 d.o.f.
		      const double mInvisible);
    TemporaryZhenyuHanWrapper_Mt2_332_Calculator();
    
  private:
    
    ZhenyuHan::mt2 * p_ZhenyuHan_mt2_pointer;
  };

} //end namespace Mt2

#endif
