c-----------------------------------------------------------------
      program Investigation
      implicit none
      include 'investigation.inc'
      double precision mslepPlus
      double precision mslepMinus

      pxpypzmAlpha(1)= 410
      pxpypzmAlpha(2)=  20
      pxpypzmAlpha(3)= -20
      pxpypzmAlpha(4)=  10

      pxpypzmBeta(1)= -210
      pxpypzmBeta(2)= -300
      pxpypzmBeta(3)=   44
      pxpypzmBeta(4)=   15

      pxpypzeG(1) = 0
      pxpypzeG(2) = 0 ! 23
      pxpypzeG(3) = 0
      pxpypzeG(4) = 0 ! 44

      mChi=100

      rootS=14000

      mslep=0
      sign=+1
      call DoMinimizationInvestigation
      mslepPlus = mslep

      mslep=0
      sign=-1
      call DoMinimizationInvestigation
      mslepMinus = mslep

      print *,'mt2+ mt2- ',mslepPlus,mslepMinus
      
      end
c-----------------------------------------------------------------
      subroutine printarray(arr,n)
      double precision arr(*)
      integer n,i
      do i=1,n
         print *,arr(i)
      enddo
      end
c-----------------------------------------------------------------
      subroutine DoMinimizationInvestigation
c-----------------------------------------------------------------
      implicit none
      include 'investigation.inc'
      double precision arglis
      integer iflag
      external myfcnInvestigation
      dimension arglis(10)
c      integer numberResets


      


      call ResetMinuitInvestigation
      
C-----Best config:      
c      arglis(1)=100
c      print *,'MIGRAD ************* 0'
c      call mnexcm(myfcnInvestigation,'SEEK',arglis,0,iflag,0)
c      print *,'MIGRAD ************* 1'
c      arglis(1)=0
c      call mnexcm(myfcnInvestigation,'MIGRAD',arglis,0,iflag,0)


c     Set maximum number of evaluations to 1000
c      arglis(1)=1000
c      call mnexcm(myfcnInvestigation,'SEEK',arglis,0,iflag,0)

      arglis(1)=0
      call mnexcm(myfcnInvestigation,'MIGRAD',arglis,0,iflag,0)

c      print *,'MIGRAD ************* 2'
c      call mnexcm(myfcnInvestigation,'IMPR',arglis,0,iflag,0)
c      if (didReset.and.numberResets.lt.10) goto 10
c      print *,'MIGRAD ************* 3'
c      call mnexcm(myfcnInvestigation,'MIGRAD',arglis,0,iflag,0)
c      print *,'MIGRAD ************* 4'
c      call mnexcm(myfcnInvestigation,'IMPR',arglis,0,iflag,0)
c      print *,'MIGRAD ************* 6'

C      arglis(1)=0
      call PackResultInvestigation
      end
c-----------------------------------------------------------------
      subroutine ResetMinuitInvestigation
c-----------------------------------------------------------------
      implicit none
c-----Little local variables
      integer i,iflag
c-----Important variables
      integer nprm
      double precision vstrt,stp,lbnd,ubnd
      external myfcnInvestigation
      double precision arglis
      dimension arglis(10)

      integer npars
      parameter (npars=2)

      character*10 pnam(npars)
      dimension nprm(npars)
      dimension vstrt(npars),stp(npars),lbnd(npars),ubnd(npars)

      data nprm /    1,       2      /
      data pnam /   'mpqlam','mhlam' /
      data vstrt/    0.5D0,   0.5D0  /
      data stp  /    0.1D0,   0.1D0  /
      data lbnd /    0.0D0,   0.0D0  /
      data ubnd /    1.0D0,   1.0D0  /

      print *,'Entering ResetMinuitInvestigation'
      arglis(1)=-1
      call mninit(5,6,7)
      call mnexcm(myfcnInvestigation,'SET PRI',arglis,1,iflag,0)
      if (iflag.ne.0) then
            print *,'Unable to set printout-level -1.'
            stop
      endif
c      call mnexcm(myfcnInvestigation,'SET NOW',arglis,0,iflag,0)
c      if (iflag.ne.0) then
c            print *,'Unable to set no-warnings.'
c            stop
c      endif
      do i=1,npars
         call mnparm(nprm(i),pnam(i),vstrt(i),
     &                       stp(i),lbnd(i),ubnd(i),iflag)
         if (iflag.ne.0) then
            print *,'Unable to set parameter ',i
            stop
         endif
      enddo

C     set to rigorous strategy
      arglis(1)=2.D0
      call mnexcm(myfcnInvestigation,'SET STRATEGY',arglis,1,iflag,0)
      if (iflag.ne.0) then
            print *,'Unable to set STRATEGY to', arglis(1)
            stop
      endif
      

      call mnseti('This is an easy one 2.')
      print *,'Leaving ResetMinuitInvestigation'
      end
c-----------------------------------------------------------------
      subroutine PackResultInvestigation
c-----------------------------------------------------------------
      implicit none
      include 'investigation.inc'
      
      integer iger1,iger2,iger3
      double precision doub0,doub1,doub2
      
      call mnstat(doub0,doub1,doub2,iger1,iger2,iger3)
      mslep=doub0
      end
c-----------------------------------------------------------------

      function pSq(pxpypz)
      implicit none
      double precision pSq
      double precision pxpypz(3) ! or longer!
      pSq = pxpypz(1)**2 + pxpypz(2)**2 + pxpypz(3)**2
      end
c-----------------------------------------------------------------
      function ptSq(pxpypz)
      implicit none
      double precision ptSq
      double precision pxpypz(2) ! or longer!
      ptSq = pxpypz(1)**2 + pxpypz(2)**2 
      end
c-----------------------------------------------------------------
      function mSq(pxpypze)
      implicit none
      double precision mSq
      double precision pxpypze(4)
c-----Functions
      double precision pSq
              external pSq
      mSq = pxpypze(4)**2 - pSq(pxpypze)
      end
c-----------------------------------------------------------------
      function trip(a,b,c)
      implicit none
      double precision a,b,c,trip
      trip = a*a + b*b + c*c - 2.0D0*(a*b + a*c + b*c)
      ! also trip = (A+B+C)*(A-B+C)*(A+B-C)*(A-B-C)
      ! where A = sqrt(a), B = sqrt(b) etc ...
      end

c-----------------------------------------------------------------
      subroutine mVecToEVec(pxpypzm,pxpypze)
      implicit none
      double precision pxpypzm(4)
      double precision pxpypze(4)
      integer i
c-----Functions
      double precision pSq
              external pSq
      do i=1,3
         pxpypze(i) = pxpypzm(i)
      enddo
      pxpypze(4) = sqrt( pSq(pxpypzm) + pxpypzm(4)**2 )
      end
c-----------------------------------------------------------------
      subroutine pxpypzeToVelocity(a,vel)
c-----------------------------------------------------------------
      implicit none
      double precision a(4)
      double precision vel(3)
      integer i
      do i=1,3
         vel(i)=a(i)/a(4)
      enddo
      end
c-----------------------------------------------------------------
      subroutine velocityToBoostMatrix(vel,boost)
c-----------------------------------------------------------------
      implicit none
      double precision boost(4,4)
      double precision vel(3)
      double precision beta,betaSq,gamma
      integer i,j

      betaSq = vel(1)**2 + vel(2)**2 + vel(3)**2
      beta = sqrt(betaSq)

      gamma = 1.0D0/sqrt(1.0D0-betaSq)

      boost(4,4) = gamma

      do i=1,3
         boost(4,i) = gamma*vel(i)
         boost(i,4) = gamma*vel(i)
      enddo

      do i=1,3
         do j=1,3
            if (i.eq.j) then
               boost(i,j)=1
            else 
               boost(i,j)=0
            endif
            boost(i,j) = boost(i,j) + vel(i)*vel(j)*(gamma-1.0D0)/betaSq
         enddo
      enddo
            
      end
c-----------------------------------------------------------------
      subroutine boostFirstToSecondByVelocity(from,to,vel)
c-----------------------------------------------------------------
      implicit none
      double precision from(4)
      double precision to(4)
      double precision vel(3)
      double precision boost(4,4)
      integer i,j
      
      call velocityToBoostMatrix(vel,boost)
      do i=1,4
         to(i)=0

         do j=1,4
            to(i)=to(i) + boost(i,j)*from(j)
         enddo
      enddo

      end
c-----------------------------------------------------------------
      subroutine negateVelocity(vel)
c-----------------------------------------------------------------
      implicit none
      integer i
      double precision vel(3)
      do i=1,3
         vel(i)=-vel(i)
      enddo
      end
c-----------------------------------------------------------------
      subroutine boostFirstToRFOfSecondAnswerInThird(a,b,c)
c-----------------------------------------------------------------
      implicit none
      double precision a(4)
      double precision b(4)
      double precision c(4)
      double precision vel(3)
      integer i,j
      
      call pxpypzeToVelocity(b,vel)
      call negateVelocity(vel)
      call boostFirstToSecondByVelocity(a,c,vel)
      end
c-----------------------------------------------------------------
      subroutine myfcnInvestigation(npar,grad,f,x,iflag,futil)
c-----------------------------------------------------------------
      implicit none
c-----Foreign params
      include 'investigation.inc'
c-----Input params
      integer npar,iflag,i
      double precision grad,f,x
c-----Output params
      double precision futil
c-----Dimensions
      dimension grad(*),x(*)
c-----Local vars
      double precision mpqMinSq,mfSq,mhSq,mhMaxSq,mpqSq,maSq,mbSq
      double precision pxpypzeAlpha(4)
      double precision pxpypzeBeta(4)
      double precision pxpypzeF(4)
      double precision pxpypzeLambda(4)
      double precision ptFSq
      double precision pxpypzeH(4)
      double precision pxpypzePQ(4)
      double precision hz,fz,ef,hzRadical


      double precision epRF, ppRF,eaRF, ebRF, sigmaRF(4), cosThetaPSigma
c-----Functions
      double precision mSq,ptSq,pSq,trip
      external         mSq,ptSq,pSq,trip
      


c-----temporary
      double precision alphaRF(4),betaRF(4),pqRF(4)
      double precision sinThetaPSigma
      double precision cosThetaAlphaSigma
      double precision sinThetaAlphaSigma
      double precision cosDeltaTheta
      double precision mslepSq
      

      print *,"pxpypzmAlpha"
      call printarray(pxpypzmAlpha,4)
      print *,"pxpypzmBeta"
      call printarray(pxpypzmBeta,4)

      maSq = pxpypzmAlpha(4)**2
      mbSq = pxpypzmBeta (4)**2
      

      print *,"pxpypzeG"
      call printarray(pxpypzeG,4)

      pxpypzeLambda(1)=0
      pxpypzeLambda(2)=0
      pxpypzeLambda(3)=0
      pxpypzeLambda(4)=1

      print *,"lambda"
      call printarray(pxpypzeLambda,4)

      call mVecToEVec(pxpypzmAlpha,pxpypzeAlpha)
      call mVecToEVec(pxpypzmBeta ,pxpypzeBeta )

      print *,"pxpypzeAlpha"
      call printarray(pxpypzeAlpha,4)
      print *,"pxpypzeBeta"
      call printarray(pxpypzeBeta,4)

c-----Calculate quantities related to F
      do i=1,4
      pxpypzeF(i) = pxpypzeLambda(i)*rootS 
     &              - pxpypzeAlpha(i) - pxpypzeBeta(i) -  pxpypzeG(i)
      enddo

      print *,"pxpypzeF"
      call printarray(pxpypzeF,4)

      mFSq = mSq(pxpypzeF)
      pTFSq = ptSq(pxpypzeF)
      
      print *, "mFSq ",mFSq, " ptFSq ", pTFSq

c-----Choose a value for mpq - using method of page (33) of lab book 6.
      mpqMinSq = (2.0D0 * mChi)**2
      mpqSq = x(1)*mFSq + (1.0D0-x(1))*mpqMinSq
      print *, "mpqMinSq ",mpqMinSq, " mpqSq ", mpqSq

c-----Choose a value for mh - using method of page (33) of lab book 6.
      mhMaxSq = 2.0D0*ptFSq + mFSq + mpqSq
     &        - 2.0D0*sqrt(ptFSq**2 + ptFSq*(mFSq+mpqSq) + mFSq*mpqSq)
      mhSq = x(2)*mhMaxSq + (1.0D0-x(2))*0.0D0
      print *, "mhMaxSq ",mhMaxSq, " mhSq ", mhSq


      print *,'mF-(mh+mpq) ',sqrt(mFSq)-(sqrt(mhSq)+sqrt(mpqSq))

c-----Calculate the vectors that are h and p+q
      fz = pxpypzeF(3)
      ef = pxpypzeF(4)


c-----Sign should be +1 or -1 in the following ....

      hzRadical =  trip(mFSq,mhSq,mpqSq)-4.0D0*mhSq*ptFSq
      hz = ( fz*(mFSq+mhSq-mpqSq) + sign*ef*sqrt(
     &                                         abs(hzRadical)
     &                         ) )/
     &       (2.0D0*(  ptFSq + mFSq   ))
      print *,' tripargs ',mFSq,' ',mhSq,' ' ,mpqSq
      print *,' trip ',trip(mFSq,mhSq,mpqSq)
      print *,' fz ',fz, ' sign ',sign,' hz ',hz, hzRadical

      pxpypzeH(1) = 0
      pxpypzeH(2) = 0
      pxpypzeH(3) = hz
      pxpypzeH(4) = sqrt(hz**2 + mhSq)

      do i=1,4
      pxpypzePQ(i) = pxpypzeF(i) - pxpypzeH(i)
      enddo

c-----Check that the mass of (P+Q) is mPQ as it is supposed to be:
      print *, 'fractional error on mPQ is ',
     &           sqrt(mSq(pxpypzePQ)/mpqSq)-1
      print *, 'fractional error on mh is              ',
     &           sqrt(mSq(pxpypzeH)/mHSq)-1

c-----It is not yet certain that it will be possible to find a direction for p and q adding to p+q such that (alpha+p)^2 == (beta+q)^2   ..... that depends on the value of "cosTheta" (see pg (28) and (29) of labbook 6).

      call boostFirstToRFOfSecondAnswerInThird(pxpypzeAlpha,pxpypzePQ,
     &                                                        alphaRF)
      call boostFirstToRFOfSecondAnswerInThird(pxpypzeBeta ,pxpypzePQ,
     &                                                         betaRF)
      call boostFirstToRFOfSecondAnswerInThird(pxpypzePQ   ,pxpypzePQ,
     &                                                           pqRF)

      print *,"alphaRF_PQ"
      call printarray(alphaRF,4)
      print *,"betaRF_PQ"
      call printarray(betaRF,4)
      print *,"pqRF_PQ with mpq ",sqrt(mpqSq)
      call printarray(pqRF,4)

c-----Now using page (28) of labbook 6:
      epRF = sqrt(mpqSq)*0.5D0 ! i.e. mpq/2
      ppRF = Sqrt(abs(epRF**2-mChi**2))  !fabs there only to control rounding errors
      eaRF = alphaRF(4)
      ebRF =  betaRF(4)
      do i=1,4
         sigmaRF(i) = alphaRF(i)+betaRF(i)
      enddo

      cosThetaPSigma = (epRF*(eaRF-ebRF)+0.5D0*(maSq-mbSq))/
     &                                 (ppRF*sqrt(pSq(sigmaRF)))

      print *,'cosThetaPSigma = ',cosThetaPSigma

      
      if (cosThetaPSigma.gt.1.0D0.or.cosThetaPSigma.lt.-1.0D0) then
         print *,'No configuration with (p+a)^2 == (q+b)^2 !'

         f=1000000
         return 
      else 
         print *,'There is a configuration with (p+a)^2 == (q+b)^2'

         sinThetaPSigma = Sqrt(1.0D0-cosThetaPSigma**2)


         cosThetaAlphaSigma = 0;
         do i=1,3
            cosThetaAlphaSigma = cosThetaAlphaSigma + 
     &           alphaRF(i)*sigmaRF(i)
         enddo
         cosThetaAlphaSigma = cosThetaAlphaSigma/
     &               sqrt(pSq(alphaRF)*pSq(sigmaRF))


         sinThetaAlphaSigma = sqrt(1.0D0-cosThetaAlphaSigma**2)

         print*,'c1,s2,c2,s2 '
     &          ,cosThetaPSigma
     &          ,sinThetaPSigma
     &          ,cosThetaAlphaSigma
     &          ,sinThetaAlphaSigma


         cosDeltaTheta = cosThetaPSigma * cosThetaAlphaSigma
     &                 + sinThetaPSigma * sinThetaAlphaSigma

c--------So in this case where (for the given values of mh and mpq) we 
c--------can find a form of p for which m=(a+p)^2==(b+q)^2 then that value of m
c--------occurs at the value of m given on page (28A) of lab book 6:

         mslepSq = maSq + mChi**2 + 2.0D0*(
     &                 eaRF*epRF
     &                 -
     &                 sqrt(pSq(alphaRF))*ppRF*cosDeltaTheta
     &             )
         print *,'mslep(candidate),x(1),x(2) = ',
     &                             sqrt(mslepSq),x(1),x(2)
         
         f=sqrt(mslepSq)
         return
      endif

   
      end
c-----------------------------------------------------------------
